# es imports
import es
import playerlib
import repeat
import usermsg
# xa imports
#from xa import xa 

#plugin information
info = es.AddonInfo()
info.name = "Pitch Black"
info.version = "1.0.0"
info.author = "Errant"
info.description = "Based on my IPGhosting mod for XA.. blind ANY dead players and spectators for funfair play"
info.tags = "blind spectators dead realism"

'''
==  Pitch Black ==
by Errant

A mod to blind all dead and spectating players
 
-- Version log --
 #     |  Type  | Date       |  Change log
1.0.0  | [FULL] | 30/07/2008 |  First version based off XAIPGhosting 1.3.2

'''

# the dictionary to track blinded players
blinded = {}
# same idea but for spectators
spec_blinded = {}


# Public variable for version
es.ServerVar("pitch_black_ver",str(info.version), "Pitch Black by Errant").makepublic()

'''
Internal classes
'''
class Player(playerlib.Player):
    '''
    Extends playerlib.Player to provide special functions
    '''
    def blind(self):
        '''
        The actual blind
        '''
        usermsg.fade(self.userid,2,500,1000,0,0,0,255)

        
'''
Internal methods
'''
def repeat_fade(x):
    '''
    Method to handle the fading. Is run every second by the repeat xaip. 
    The fade is set to fade out so on round end you get a nice fade out effect for the player
    '''
    for uid in blinded:
        blinded[uid].blind()
        
def repeat_fade_spec(x):
    '''
    As above but for the spectators dict
    '''
    for uid in spec_blinded:
        spec_blinded[uid].blind()

def blindplayer(uid):
    '''
    - Starts the fade repeat if it isn't already running
    - Fades out the player
    - Tell them 3 times they have been blinded
    '''
    global blinded
    if repeat.status("blind") == 0:
        a = repeat.create("blind", repeat_fade)
        a.start(1,0)
    # do the initial fade 
    blinded[uid] = Player(uid)
    blinded[uid].blind()
    # tell them
    blinded[uid].tell_blinded()
    # log that they were blinded

                
def blindplayer_spec(uid):
    '''
    As above but for the spectator Dict
    '''
    global spec_blinded
    if repeat.status("blind_spec") == 0:
        a = repeat.create("blind_spec", repeat_fade_spec)
        a.start(1,0)
    # do the initial fade 
    spec_blinded[uid] = Player(uid)
    spec_blinded[uid].blind()

    

    
def remove_from_spec(uid):
    '''
    Removes the user from the spec dict and stops the repeat if the dict is empty
    '''
    global spec_blinded
    spec_blinded.pop(uid)
    if len(spec_blinded) < 1:
        # no one IP ghosting as spec so kill the repeat
        if repeat.status("xaip_spec") > 0:
            r = repeat.find("xaip_spec")
            r.stop()
            r.delete()
                
'''
Events
'''
def load():
    es.msg("Pitch Black by Errant has been loaded!")


def player_death(event_var):
    '''
    If player is IP ghosting add them to the list! And if the repeat is not fired yet then do that too!
    '''
    blindplayer(event_var['userid'])
        

def round_end(event_var):
    '''
    On the round end delete the keys from our dict of ghosters and also end the repeat to minimize server load
    '''
    global blinded
    if repeat.status("blind") > 0:
        r = repeat.find("blind")
        r.stop()
        r.delete()
    blinded = {}
    
def player_team(event_var):
    '''
    Blinds a player when they switch to spec (and unblinds when they go bacK)
    '''
    if not int(event_var['disconnect']):
        if int(event_var['team']) == 1:
            blindplayer_spec(event_var['userid'])
        if int(event_var['team']) > 1 and  event_var["userid"] in spec_blinded:
            # check they are not on the list and remove them
            remove_from_spec(event_var['userid'])
        
def player_disconnect(event_var):
    '''
    When a player disconnects remove them fro mthe dictionaries (to avoid errors)
    '''
    if event_var["userid"] in blinded:
        # player is currently beign blinded
        blinded.pop(event_var["userid"])
    if event_var["userid"] in spec_blinded:
        # player is currently beign blinded
        remove_from_spec(event_var['userid'])
            
def unload():
    # ther round end event is handy to reuse here..
    round_end(False)
    # and kill the spectator loop
    if repeat.status("blind_spec") > 0:
        r = repeat.find("blind_spec")
        r.stop()
        r.delete()
    es.msg("Pitch Black is unloaded")
